package com.company.combobox.entity;

import io.jmix.core.metamodel.datatype.impl.EnumClass;

import javax.annotation.Nullable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public enum MusicStyle implements EnumClass<Integer> {

    FREE_JAZZ(10),
    JAZZ_FUSION(20),
    BIG_BAND_JAZZ(30),
    HARD_ROCK(40),
    SOFT_ROCK(50),
    SOUTHERN_ROCK(60),
    HEAVY_METAL(70),
    SPEED_METAL(80),
    PROGRESSIVE_METAL(90);

    private final Integer id;

    MusicStyle(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    @Nullable
    public static MusicStyle fromId(Integer id) {
        for (MusicStyle at : MusicStyle.values()) {
            if (at.getId().equals(id)) {
                return at;
            }
        }
        return null;
    }

    public static List<MusicStyle> getMusicStyleList(MusicStyleCategory musicStyleCategory) {

        switch (musicStyleCategory) {
            case JAZZ:
                return (getMusicStyleNameJAZZ());
            case ROCK:
                return (getMusicStyleNameROCK());
            case METAL:
                return (getMusicStyleNameMETAL());
        }

        return (getMusicStyleNameALL());
    }

    private static List<MusicStyle> getMusicStyleNameJAZZ() {
        return (new ArrayList<>(Arrays.asList(MusicStyle.FREE_JAZZ, MusicStyle.JAZZ_FUSION, MusicStyle.BIG_BAND_JAZZ)));
    }

    private static List<MusicStyle> getMusicStyleNameROCK() {
        return (new ArrayList<>(Arrays.asList(MusicStyle.HARD_ROCK, MusicStyle.SOFT_ROCK, MusicStyle.SOUTHERN_ROCK)));
    }

    private static List<MusicStyle> getMusicStyleNameMETAL() {
        return (new ArrayList<>(Arrays.asList(MusicStyle.HEAVY_METAL, MusicStyle.SPEED_METAL, MusicStyle.PROGRESSIVE_METAL)));
    }

    private static List<MusicStyle> getMusicStyleNameALL() {
        return (new ArrayList<>(Arrays.asList(MusicStyle.FREE_JAZZ, MusicStyle.JAZZ_FUSION, MusicStyle.BIG_BAND_JAZZ,
                MusicStyle.HARD_ROCK, MusicStyle.SOFT_ROCK, MusicStyle.SOUTHERN_ROCK,
                MusicStyle.HEAVY_METAL, MusicStyle.SPEED_METAL, MusicStyle.PROGRESSIVE_METAL)));
    }
}