package com.company.combobox.entity;

import io.jmix.core.metamodel.datatype.impl.EnumClass;

import javax.annotation.Nullable;


public enum Rating implements EnumClass<Integer> {

    NONE(10),
    ONE_STAR(20),
    TWO_STARS(30),
    THREE_STARS(40),
    FOUR_STARS(50),
    FIVE_STARS(60);

    private final Integer id;

    Rating(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    @Nullable
    public static Rating fromId(Integer id) {
        for (Rating at : Rating.values()) {
            if (at.getId().equals(id)) {
                return at;
            }
        }
        return null;
    }
}