package com.company.combobox.screen.musicchoice;

import com.company.combobox.entity.MusicStyle;
import com.company.combobox.entity.MusicStyleCategory;
import com.company.combobox.entity.Rating;
import io.jmix.ui.component.ComboBox;
import io.jmix.ui.component.HasValue;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.*;
import com.company.combobox.entity.MusicChoice;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Objects;

import static com.company.combobox.entity.MusicStyle.getMusicStyleList;

@UiController("MusicChoice.edit")
@UiDescriptor("music-choice-edit.xml")
@EditedEntityContainer("musicChoiceDc")
public class MusicChoiceEdit extends StandardEditor<MusicChoice> {

    @Autowired
    private InstanceContainer<MusicChoice> musicChoiceDc;
    @Autowired
    private ComboBox<MusicStyle> styleField;
    @Autowired
    private ComboBox<Rating> ratingField;

    @Subscribe
    public void onAfterShow(final AfterShowEvent event) {
        styleField.setOptionsList(getMusicStyleList(musicChoiceDc.getItem().getCategory()));
    }

    @Subscribe("categoryField")
    public void onCategoryFieldValueChange(final HasValue.ValueChangeEvent<MusicStyleCategory> event) {
        styleField.setOptionsList(getMusicStyleList(Objects.requireNonNull(event.getValue())));
        styleField.setValue(null);
        ratingField.setValue(null);
    }
}